#!/bin/sh
####################################################################################
# Fichero:rotaBackups.sh
# Descripcion:Script que rota mensualmente los backups. De momento rota:
#- backups de mes anterior: los comprime y tarea.
#Tambien borra los mas antiguos de 2 meses (de momento no)
# Autor: Eduardo Gonzalez de la Herran
# Fecha: 20040602
# Modifs:
#####################################################################################

fecha_total=`date +"%d/%m/%Y %H:%M:%S"`
fecha_ano_mes=`date +"%Y%m"`
FILE_LOG=/root/scripts/logs/rotaBackups.log.$fecha_ano_mes.txt
DIR_BACKUPS="/backups"
ANYO_ACTUAL=`date +"%Y"`
MES_ACTUAL=`date +"%m"`
# Obtenemos el mes anterior en el formato adecuado
MES_ANTERIOR=`expr \( \( $MES_ACTUAL - 1 \) % 12 \) \| 12`
test `expr length $MES_ANTERIOR` -eq 1 && MES_ANTERIOR="0$MES_ANTERIOR"

test "$MES_ANTERIOR" -eq 12 && ANYO_ACTUAL = `expr $ANYO_ACTUAL - 1`

echo "$fecha_total --- INICIO EJECUCION ---" >> $FILE_LOG

# Actualmente solo hay un directorio de Backups, pero por si se aniaden mas...
for directorio in $DIR_BACKUPS; do
	echo "Tratando directorio de backups... $directorio" >> $FILE_LOG
	# Buscamos en el directorio de backups todos los directorios de primer nivel (maquinas supuestamente)
	for maquina in `find $directorio -type d -mindepth 1 -maxdepth 1`; do
		# En cada maquina, comprimimos y tareamos directorio del mes anterior
		if [ -d $maquina/$ANYO_ACTUAL$MES_ANTERIOR ]; then
			echo -n "COMPRIMIENDO: $maquina/$ANYO_ACTUAL$MES_ANTERIOR..." >> $FILE_LOG
			if tar -cjf $maquina/$ANYO_ACTUAL$MES_ANTERIOR.bz2 $maquina/$ANYO_ACTUAL$MES_ANTERIOR 2>&1 >> $FILE_LOG; then
				echo " OK!" >> $FILE_LOG
				# Borramos directorio CON CUIDADO!!
				test "$maquina" != "" && test "$ANYO_ACTUAL$MES_ANTERIOR" != "" && rm -R $maquina/$ANYO_ACTUAL$MES_ANTERIOR && echo "BORRADO DIRECTORIO $maquina/$ANYO_ACTUAL$MES_ANTERIOR" >> $FILE_LOG
			else
				echo " FALLO!" >> $FILE_LOG
			fi
		fi
	done
done
echo "--- FIN EJECUCUCION ---" >> $FILE_LOG
echo >> $FILE_LOG
